#include "usgard.h"

.org 0

TITL:
 .db "  DuckHunt 85  v1.0  ",0

;------------------------Begin the Program--------------------------------
init:
 call CLEARLCD    ;Clears the Screen

;------------------------Displays the Title Screen---------------------------
title:
 call CLEARLCD
 set  3,(IY+05)
 ld   HL,0
 ld   (CURSOR_ROW),HL
 ld   HL,&TITL
 call D_ZT_STR
 res  3,(IY+05)
 ld   de,$0810
 ld   hl,&CREDITS1
 call &PutText
 ld   de,$1013
 ld   hl,&CREDITS2
 call &PutText
 ld   de,$1805
 ld   hl,&CONTROLS
 call &PutText
 ld   de,$2010
 ld   hl,&SECONDSHOOTS
 call &PutText
 ld   de,$2810
 ld   hl,&ENTERPAUSE
 call &PutText
 ld   de,$3010
 ld   hl,&EXITQUITS
 call &PutText
 ld   de,$3A00
 ld   hl,&HIGHSCORE
 call &PutText
 ld   a,$50
 ld   e,$25
 ld   hl,&drwu
 call &PutSprite
 ld   a,$65
 ld   e,$27
 ld   hl,&gun
 call &PutSprite
 call GET_KEY
titleloop:
 call GET_KEY
 cp   K_EXIT
 ret  z
 cp   K_ENTER
 jr   z,Start
 jr   titleloop

;---------------------Puts the BackGround on the Screen ---------------------
putBG:
 ld   DE,$FC00
 ld   BC,1024
 ld   HL,&PIC_DUCKHUNT ;Pic Name for Loading
 ldir                  ;Sends to the Screen
 ret
;----------------------------Start Game --------------------------------------
Start:
 call &varInit ;Variable Init
 call &nrInit  ;New Round Init
 call &ndInit  ;Initialize Duck
 call CLEARLCD
 call &putBG
 call &PutGun  ;Put the Gun
 jr   Loop     ;Goto Loop

NewRound:
 call &nrInit   ;Initialize Round
 call CLEARLCD
 call &putBG
 
NewDuck:
 call &ndInit ;Initialize Duck
 call &PutGun ;Put the Gun
Loop:
 call &dispScore
 call &LoadDuck ;Loads the Duck
 ld   a,(ducky) ;Duck Y Coordinate into A
 ld   e,a       ;That into E
 ld   a,(duckx) ;Duck X into A
 call &PutSprite
 jp   &GetKeyLoop
 
NoKey:
SkipDelay:
 ld   a,(moves)   ;moves->a
 cp   200         ;has the duck moved # times?
 jp   z,&flyaway  ;if so, fly away
 call &LoadDuck   ;Load Duck
 ld   a,(ducky)   ;ducky->a
 ld   e,a ;a->e
 ld   a,(duckx)   ;duckx->a
 call &PutSprite  ;Clear it!
 jp   &chwing     ;call routine to change wing

wingch:        ;return from chwing. (Wing status changed)
 jp   &chkdloc ;check location (if on any edges, change movement direction.)

rchk:        ;return from check
 call &dmove ;move duck!
 jp   &Loop  ;go to beginning of duck moving routine

;------change wing (up or down)----
chwing:
 ld   a,(wing)   ;wing->a
 inc  a          ;a+1->a
 ld   (wing),a   ;a->wing
 cp   3          ;is a 3?
 jp   nz,&wingch ;if not, goto wing changed (it must be 2)
 ld   a,1        ;(else, reset  wing to 1)... 1->a
 ld   (wing),a   ;a->wing
 jp   &wingch     ;return from chwing

;-------Erase Duck/Gun-------
erdc:
 ld   a,(guny)   ;Loads GunY into A
 ld   e,a        ;A into E
 ld   a,(gunx)   ;GunX into A
 ld   hl,&gun    ;Gun into HL
 call &PutSprite ;Clear the Sprite!
 call &LoadDuck  ;Load DuckSprite
 ld   a,(ducky)  ;Load DuckY into A
 ld   e,a        ;Loads A into E
 ld   a,(duckx)  ;Loads DuckX into A
 call &PutSprite ;Clear it!
 ret             ;Return

;---------display score---------
dispScore:
 ld   hl,$393B      ;Row=57,Col=58
 ld   (CURSOR_X),hl ;set  those coords
 ld   hl,(score)    ;score->hl
 call DM_HL_DECI
 ret                ;return
 
;-------move duck------------
dmove:
 ld   a,(moves) ;moves->a
 inc  a         ;a+1->a
 ld   (moves),a ;a->moves
 ld   a,(dirlr) ;dirlr->a
 cp   1         ;is duck moving right?
 jp   z,&inca   ;if so, increment duckx
 ld   a,(duckx) ;duckx->a
 dec  a         ;a-1->a
 ld   (duckx),a ;into duckx

rinc:           ;return from inc
 ld   a,(dirud) ;dirud->a
 cp   1         ;is duck moving up?
 jp   z,&deca   ;if so, goto decrement a
 ld   a,(ducky) ;ducky->a
 inc  a         ;a+1->a
 ld   (ducky),a
 ret

inca:
 ld   a,(duckx) ;duckx->a
 inc  a         ;a+1->a
 ld   (duckx),a ;back into duckx
 jp   &rinc     ;return from increment
deca:
 ld   a,(ducky) ;ducky->a
 dec  a ;a-1->a
 ld   (ducky),a
 ret

;--------duck fly away------
flyaway:
 call &erdc    ;erase duck and cursor
 ld   de,$1422 ;Row=20,Col=34
 ld   hl,&fas  ;fly away string
 call &PutText ;put string on graph!

flyaway1:
 ld   a,(ducky)   ;duck y-coord->a
 ld   e,a ;a->e
 ld   a,(duckx)   ;duck x-coord->a
 ld   hl,&faway   ;faway sprite->bc
 call &PutSprite  ;call SPRxor  routine
 call &delay      ;delay
 ld   a,(ducky)   ;duck y-coord->a
 ld   e,a ;a->e
 ld   a,(duckx)   ;duck x-coord->a
 ld   hl,&faway   ;faway sprite->bc
 call &PutSprite  ;call SPRxor  routine
 ld   a,(ducky)   ;duck y-coord->a
 or   a           ;top of the screen? (a=0?)
 jp   z,&fadvance ;if so, goto fadvance
 dec  a           ;a-1->a (to decrease y-coord)
 ld   (ducky),a   ;a->duck y-coord
 jp   &flyaway1   ;loop!

;------check duck's location-------------
chkdloc:
 ld   a,84
 ld   b,a
 ld   a,(duckx)
 cp   b
 jp   nc,&MakeDir2
 ld   a,(duckx)
 cp   1
 jp   z,&MakeDir1

nchk:
 ld   a,(ducky)  ;ducky->a (duck's y-coord)
 cp   1          ;is y-coord 1?
 jp   z,&chdirud ;if so, goto change duck's ud direction
 cp   38         ;is y-coord 38?
 jp   z,&chdirud ;if so, goto change duck's ud direction
 jp   &rchk

MakeDir2:
 ld   a,2
 ld   (dirlr),a
 jr   nchk

MakeDir1:
 ld   a,1
 ld   (dirlr),a
 jr   nchk

chdirud:         ;change duck's ud movement
 ld   a,(dirud)  ;dirud->a
 inc  a          ;a+1->a
 ld   (dirud),a  ;a->dirud
 cp   3          ;is dirud 3?
 jp   nz,&rchk   ;if not, return (that means dirud is 2)
 ld   a,1        ;(otherwise... set  it back to 1) 1->a
 ld   (dirud),a  ;a->dirud
 jp   &rchk      ;return from chk

;----KeyLoop----
GetKeyLoop:
 call &delay ;Create a delay
 ld   a,(KEY_1)
 cp   K_RIGHT
 jp   z,&GunRight
 cp   K_LEFT
 jp   z,&GunLeft
 cp   K_UP
 jp   z,&GunUp
 cp   K_DOWN
 jp   z,&GunDown
 cp   K_SECOND
 jp   z,&shoot
 cp   K_MORE
 jp   z,&QuickPause
 cp   K_EXIT
 jp   z,&init
 jp   nz,&NoKey

QuickPause:
 call GET_KEY
 or   a
 jr   z,QuickPause
 jr   GetKeyLoop

;--------put move (of gun)---------
PutMove:
 call &PutGun ;re-display crosshairs
 jp   &SkipDelay ;return from gtkey, skipping delay

;-----Keys to Move-----
GunUp:
 ld   a,(guny) ;gun y-coord->a
 or   a        ;a=0? (top of screen?)
 jp   z,&NoKey ;if so, NoKey
 call &PutGun
 ld   a,(guny) ;gun y-coord->a
 dec  a        ;a-1->a (to move up)
 dec  a        ;a-1->a (to move up)
 ld   (guny),a ;a->gun y-coord
 jr   PutMove  ;put gun move

GunDown:
 ld   a,(guny) ;gun y-coord->a
 cp   38       ;a=38? (grass line?)
 jp   z,&NoKey ;if so, goto NoKey
 call &PutGun
 ld   a,(guny) ;gun y-coord->a
 inc  a        ;a+1->a (to move down)
 inc  a        ;a+1->a (to move down)
 ld   (guny),a ;a->gun y-coord
 jp   &PutMove ;put gun move

GunLeft:
 ld   a,(gunx) ;gun x-coord->a
 or   a        ;a=0? (left side of screen)
 jp   z,&NoKey ;if so, goto NoKey
 call &PutGun
 ld   a,(gunx) ;gun x-coord->a
 dec  a        ;a-1->a (to move left)
 dec  a        ;a-1->a (to move left)
 ld   (gunx),a ;a->gun x-coord
 jp   &PutMove ;put gun move

GunRight:
 ld   a,(gunx) ;gun x-coord->a
 cp   88       ;a=88? (right side of screen)
 jp   z,&NoKey ;if so, goto NoKey
 call &PutGun
 ld   a,(gunx) ;gun x-coord->a
 inc  a        ;a+1->a (to move right)
 inc  a        ;a+1->a (to move right)
 ld   (gunx),a ;a->gun x-coord
 jp   &PutMove ;Put GunMove

;--------shoot gun!---------
shoot:
 ld   a,(guny)
 ld   e,a
 ld   a,(gunx)
 ld   hl,&gun
 call &PutSprite
 ld   a,(guny)   ;gun y-coord->a
 ld   e,a        ;a->e
 ld   a,(gunx)   ;gun x-coord->a
 ld   hl,&shot   ;sprite shot->bc
 call &PutSprite ;call Movax's sprite routine
 call &delay     ;delay
 call &delay     ;delay
 call &delay     ;delay
 ld   a,(guny)   ;gun y-coord->a
 ld   e,a ;a->e
 ld   a,(gunx)   ;gun x-coord->a
 ld   hl,&shot   ;sprite shot->bc
 call &PutSprite ;call Movax's sprite routine
 ld   a,(guny)
 ld   e,a
 ld   a,(gunx)
 ld   hl,&gun
 call &PutSprite

;---------erase a bullet------
erasebul:
 ld   hl,$390E
 ld   (CURSOR_X),hl
 ld   a,(bullets)
 cp   10
 call z,&Write10
 add  a,'0'
 call M_CHARPUT
; ret

;---------check for hit-------
CheckForHit:
 ld   a,(gunx)         ;Loads Gun X into A
 add  a,4              ;add 4 to A [Middle of Sprite]
 ld   b,a              ;Loads A into B
 ld   a,(duckx)        ;Loads Duck X into A
 cp   b                ;Compares  a to b
 jp   c,&ContinueCheck ;Continue Checking if a>b
 jr   subbull          ;Missed Otherwise

ContinueCheck:
 ld   a,(duckx)    ;Duck X into A
 add  a,4          ;add 4 to A
 ld   b,a          ;Loads A into B
 ld   a,(gunx)     ;Gun X into A
 cp   b            ;Compare A to B
 jp   c,&CheckYHit ;If b>a then check Y-Coord
 jp   &subbull     ;You missed otherwise

CheckYHit:
 ld   a,(guny)          ;Loads Gun X into A
 add  a,4               ;add 4 to A
 ld   b,a               ;Loads A into B
 ld   a,(ducky)         ;Loads Duck X into A
 cp   b                 ;Compares a to b
 jp   c,&ContinueCheckY ;Continue Checking if a>b
 jr   subbull           ;Missed Otherwise

ContinueCheckY:
 ld   a,(ducky) ;Duck X into A
 add  a,4       ;add 4 to A 
 ld   b,a       ;Loads A into B
 ld   a,(guny)  ;Gun X into A
 cp   b         ;Compare A to B
 jp   c,&hit    ;If b>a then Hit!!!
 jp   &subbull  ;You missed otherwise

;---------subtract bullet from remaining--------
subbull:
 ld   a,(bullets)  ;bullets left->a
 dec  a ;a-1->a
 ld   (bullets),a  ;a->bullets
 or   a            ;zero? (out of bullets?)
 jp   z,&flyaway   ;if so, goto flyaway!
 ld   hl,$390E
 ld   (CURSOR_X),hl
 ld   a,(bullets)
 cp   10
 call z,&Write10
 add  a,'0'
 call M_CHARPUT
 jp   &NoKey       ;return from getkey

;-----------A HIT!!!----------------
hit:
 call &erdc    ;erase duck and cursor!
 ld   a,(dhit) ;ducks hit->a
 inc  a        ;a+1->a
 ld   (dhit),a ;a->ducks hit
 ;------------update score------------
 ld   a,(bullets) ;bullets remaining->a
 ld   h,a
 ld   a,15        ;15->a
 ld   l,a
 call MUL_HL
 ld   de,(score)
 add  hl,de
 ld   (score),hl  ;hl->score
hitloop:
 ld   a,(ducky)   ;duck y-coord->a
 ld   e,a ;a->e
 ld   a,(duckx)   ;duck x-coord->a
 ld   hl,&hitduck ;sprite hitduck->bc
 call &PutSprite  ;call movax's sprite routine
 call &delay      ;delay
 ld   a,(ducky)   ;duck y-coord->a
 ld   e,a ;a->e
 ld   a,(duckx)   ;duck x-coord->a
 ld   hl,&hitduck ;sprite hitduck->bc
 call &PutSprite  ;call movax's sprite routine
 ld   a,(ducky)   ;duck y-coord->
 inc  a           ;a+1->a (make him go one more down the screen)
 ld   (ducky),a   ;a->duck y-coord
 cp   38          ;is it 38? (grass line?)
 jp   nz,&hitloop ;if not, loop again
 jp   &advance

;----------advance stats---------
fadvance: ;This simply deletes the text that says "FlyAway"
 ld   de,$1422
 ld   (CURSOR_X),de
 ld   b,32
delloop:
 ld a,32
 call M_CHARPUT
 djnz delloop

advance:          ;advance duck, round, or even END of game
 ld   a,(curduck) ;current duck #->a
 cp   10          ;duck #10? (new round?)
 jp   z,&rndovr   ;if so, goto round over
 ret  z
 inc  a           ;a+1->a (increase current duck #)
 ld   (curduck),a ;a->current duck #
 jp   &NewDuck    ;new duck!

;---------round over--------------
rndovr:
 ld   de,$0A0A    ;Row=20,Col=10
 ;-----Show how many hit/needed-------
 ld   hl,&youhit  ;"You hit "
 call &PutText    ;put string on graph
 ld   a,(dhit)    ;# ducks hit->a
 cp   10
 call z,&Write10
 add  a,'0'
 call M_CHARPUT
 ld   hl,&andneed ;" and needed "
 call D_ZM_STR    ;put string on graph
 ld   a,(needed)  ;# needed to advance->a
 cp   10
 call z,&Write10
 add  a,'0'
 call M_CHARPUT
 ;---------Check for round clear!--------
 ld   a,(dhit)  ;# needed to advance->a
 inc  a         ;Increase it, so that if they are =, it works out
 ld   b,a
 ld   a,(needed)
 cp   b
 jp   nc,&exit
 ;-----if you've made it here, ROUND CLEAR!---------
 ld   de,$141C      ;Row=30,Col=28
 ld   hl,&rndclr    ;"Round Clear!"
 call &PutText      ;put string on graph!
 ld   a,(dhit)      ;# ducks hit->a
 cp   10            ;did you hit all 10 ducks?
 jp   nz,&noperfect ;if not skip perfect, goto NOPERFECT!
 ld   hl,(score)    ;score->hl
 ld   de,250
 add  hl,de
 ld   (score),hl    ;hl->score
 ld   de,34         ;Row=0,Col=34
 ld   hl,&perfect   ;"PERFECT!"
 call &PutText      ;put string on graph
 ld   de,21         ;Row=10,Col=21
 ld   hl,&bonus     ;"250 point BONUS!"
 call &PutText      ;put string on graph
noperfect:
 call OTH_PAUSE
 call &delay        ;delay
 call &delay        ;delay
 call &delay        ;delay
 call &delay        ;delay
 ld   a,(round)     ;round #->a
 cp   5             ;round #5?
 jp   z,&winner     ;if so, you win!
 inc  a             ;a+1->a
 ld   (round),a     ;a->round
 ld   hl,(dlay)     ;dlay->hl
 ld   de,$FA00
 add  hl,de
 ld   (dlay),hl
 jp   &NewRound     ;new round!!!

;--------WINNER!-------------
winner:
 call CLEARLCD      ;Clear the Screen
 ld   de,7          ;Row=0,Col=7
 ld   hl,&congrats1 ;first line of congrats string
 call &PutText      ;put string on graph!
 ld   de,$0609      ;Row=6,Col=9
 ld   hl,&congrats2 ;second line of congrats string
 call &PutText      ;put string on graph!
 ld   de,$0C0E      ;Row=12,Col=14
 ld   hl,&congrats3 ;third line of congrats string
 call &PutText      ;put string on graph!
 ld   de,$1200      ;Row=18,Col=0
 ld   hl,&congrats4 ;fourth line of congrats string
 call &PutText      ;put string on graph!

exit:
 ld   de,$181E     ;Row=29,Col=33
 ld   hl,&gameover ;"GAME OVER!"
 call &PutText     ;put string on graph!
 ld   de,$1F1E     ;Row=37,Col=30
 ld   hl,&scr      ;"SCORE = "
 call &PutText     ;put string on graph!
 ld   hl,(score)   ;score->hl
 call DM_HL_DECI
 call OTH_PAUSE
 call CLEARLCD
 ld   hl,(&hiscore)
 ld   de,(score)
 call CP_HL_DE
 jp   nc,&init     ;return to normal calc mode (quit prog)
 ld   de,0
 ld   hl,&newscore
 call &PutText
 ld   hl,$0001
 ld   (CURSOR_ROW),hl
 ld   de,(score)
 ld (&hiscore),de
 ld   ix,&HIGHSCORE+15
 ld   b,4
 ld   hl,(score)
DispHighscore:
 call UNPACK_HL
 add  a,'0'
 ld   (ix),a
 dec  ix
 djnz DispHighscore
 ld   a,3
 ld   hl,&HIGHSCORE+20
 call &Input
 jp   &init

Input:
 ei
 set  2,(iy+12)   ; * Turn cursor blinking on (interrupts must be enabled)
 ld   (noLet),a   ; Store the maximum lenght of the string
 ld   e,0         ; E = numbers of letters written so far
WaK:
 ld   a,32
 ld   ($800E),a   ; * set  "character under cursor" to space
 push hl          ; * Save HL since GET_KEY destroys it's content
 call GET_KEY
 cp   $02         ; $02 = left key
 jr   z,BackSpace
 cp   $09         ; $09 = enter
 jr   z,NameDone
 cp   $11         ; $11 = space
 jr   nz,CheckLetter
 ld   a,32        ; Space is ascii char 32
 pop  hl
 jr   PutLetter   ; Put the letter on screen and in memory
CheckLetter:
 ld   hl,&Letters ; HL -> letter table
 ld   bc,26       ; 26 letters to check
 cpir             ; Compare A with each letter until a match is found
 ld   d,c         ; Then C = the letter. Store in D
 pop  hl          ; HL -> current position in string
 jr   nz,WaK      ; If not valid keystroke, wait for new key
 ld   a,65        ; 65 = ascii char for A
 add  a,d         ; A now holds the ascii char for the letter pressed
PutLetter:
 ld   c,a
 ld   a,(noLet)   ; A = max letters
 cp   e           ; Check if max size is reached
 jr   z,WaK       ; If so, wait for a new key
 ld   (hl),c      ; If not, store the key entered
 inc  hl          ; Point to the next byte in the string
 inc  e           ; And increase the letter counter
 ld   a,c
 call TX_CHARPUT  ; Show the chars pressed on the screen
 jr   WaK         ; And jump back and wait for a new key
BackSpace:
 pop  hl          ; HL -> current position in string
 ld   a,e
 or   a           ; Check if string size = 0
 jr   z,WaK       ; If so, backspace is impossible. Check for new key.
 res  2,(iy+12)   ; * Stopp cursor blinking
 dec  e           ; Decrease string size
 dec  hl          ; And string pointer
 push hl
 ld   hl,$800D    ; HL -> x cursor position
 dec  (hl)        ; Decrease it
 ld   a,32        ; Overwrite the last letter with a space
 call TX_CHARPUT  ; Put the space over the chars
 call TX_CHARPUT  ; * And over the blinking cursor
 dec  (hl)        ; * Decrease the x coordinate twice
 dec  (hl)
 pop  hl
 set  2,(iy+12)   ; * Start cursor blinking
 jr   WaK         ; Wait for a key
NameDone:
 pop  hl          ; HL -> current position in string
 ld   (hl),0      ; Put a terminating zero at the end of the string
 res  2,(iy+12)   ; * Stopp cursor blinking
 ret

; The keycodes of the letters A-Z stored backways

Letters:
 .db $19,$21,$0A,$12,$1A,$22,$0B,$13,$1B,$23,$2B
 .db $0C,$14,$1C,$24,$2C,$0D,$15,$1D,$25,$2D,$0E
 .db $16,$1E,$26,$2E

;----------Initialize new round stuff--------------
nrInit: ;new round initialize
 call CLEARLCD ;clear screen
 call &putBG
 ld   a,44 ;44->a
 ld   (gunx),a ;a->gun x-coord
 ld   a,20 ;20->a
 ld   (guny),a ;a->gun y-coord
 ld   a,1 ;1->a
 ld   (curduck),a ;a->current duck (1)
 sub a ;0->a
 ld   (dhit),a ;a->dhit (no ducks hit yet! duh)
 ld   a,(round) ;round->a
 ld   b,a ;a->b
 ld   a,5 ;5->a
 add  a,b ;a+b->a
 ld   (needed),a ;a->needed
 ld   de,10*256+35 ;Row=20,Col=35
 ld   hl,&rnd ;"Round "
 call &PutText ;put string on graph!
 ld   a,(round) ;round->hl
 cp   10
 call z,&Write10
 add  a,'0'
 call M_CHARPUT
 ld   de,20*256+20 ;Row=30,Col=15
 ld   (CURSOR_X),hl ;set  these coords
 call &PutText ;put string on graph!
 ld   a,(needed) ;Needed to hl
 cp   10
 call z,&Write10
 add  a,'0'
 call M_CHARPUT
 ld   hl,&outof10 ;" out of 10 ducks!"
 call D_ZM_STR ;put string
 call OTH_PAUSE ;wait for key
 call &delay ;delay
 call &delay ;delay
 call &delay ;delay
 ret  ;return from new round initialize

varInit:
 ld   hl,0 ;0->a
 ld   (score),hl ;a->score
 ld   a,1 ;1->a
 ld   (round),a ;a->current round (1 to start)
 ld   bc,$2000 ;initial delay length (2000)->bc
 ld   (dlay),bc ;bc->dlay
 ret

;-----------Initialize new duck stuff----------------
ndInit: ;new duck initialize
 ld   a,44 ;44->a
 ld   (gunx),a ;a->gun x-coord
 ld   a,20 ;20->a
 ld   (guny),a ;a->gun y-coord
 ld   a,3 ;3->a
 ld   (bullets),a ;a->bullets
 ld   hl,57*256+14
 ld   (CURSOR_X),hl
 ld   a,(bullets)
 cp   10
 call z,&Write10
 add  a,'0'
 call M_CHARPUT
 ld   a,1 ;1->a
 ld   (wing),a ;a->wing
 ld   (moves),a ;a->moves
 ld   (dirud),a ;a->dirud
 ld   a,37 ;37->a
 ld   (ducky),a ;a->ducky
RANDOMA:
 call RANDOM
 cp   85
 jr   nc,RANDOMA
 ld   (duckx),a ;a->duckx (a contains the random #)
 call RANDOM
 bit 1,A
 call &Load1DirLR ;Load 1
 call nz,&Load2DirLR ;Load 2
 ld   hl,57*256+29 ;Row=57,Col=26
 ld   (CURSOR_X),hl ;set  those coords
 ld   a,(curduck) ;current duck->a
 cp   10
 call z,&Write10
 add  a,'0'
 call M_CHARPUT
 ld   hl,57*256+47 ;Row=57,Col=43
 ld   (CURSOR_X),hl ;set  those coords
 ld   a,(dhit) ;ducks hit->a
 cp   10
 call z,&Write10
 add  a,'0'
 call M_CHARPUT ;Display it!
 ret  ;return from new duck initialize

Write10:
 ld   A,$31
 call M_CHARPUT
 sub A
 ret

Load1DirLR:
 ld   a,1
 ld   (dirlr),a
 ret

Load2DirLR:
 ld   a,2
 ld   (dirlr),a
 ret

;---------display gun---------

PutGun:
 ld   a,(guny) ;gun y-coord->a
 ld   e,a ;a->e
 ld   a,(gunx) ;gun x-coord->a
 ld   hl,&gun ;sprite gun->hl
 call &PutSprite ;PutSprite
 ret  ;return

;------ld   which sprite (direction and wing up or down)----
LoadDuck:
 ld   a,(wing) ;wing->a
 cp   2 ;wing down?
 jp   z,&down ;if so,jump to down
 ld   a,(dirlr) ;dirlr->a
 cp   2 ;left?
 jp   z,&uleft ;if so, jump to (facing) up,left
 ld   hl,&drwu ;if none of these, sprite drwu->bc 
 ret  ;duck loaded
uleft:
 ld   hl,&dlwu ;sprite dlwu->bc
 ret  ;duck loaded
down:
 ld   a,(dirlr) ;dirlr->a
 cp   2 ;left?
 jp   z,&dleft ;if so,jump to (facing) down,left
 ld   hl,&drwd ;otherwise, sprite drwd->bc
 ret  ;jp   duckldd
dleft:
 ld   hl,&dlwd ;sprite dlwd->bc
 ret  ;jp   duckldd

;-----delay loop--------
delay:
 push af ;hide current AF value
 push bc ;hide current BC value 
 ld   bc,(dlay) ;dlay length->bc
delayLoop:
 dec  bc ;bc-1->bc
 ld   a,b ;Loads b into a
 or   c ;Checks if c=0
 jr   nz,delayLoop ;if not, continue loop 
 pop  bc ;unhide current BC value
 pop  af ;unhide current AF value 
 ret

PutText:
 ld (CURSOR_X),de
 call D_ZM_STR
 ret


;------------------
; Sprite Routine [XOR]
;------------------

;------------------
;This Routine was converted by AVD from Movax's 83
;Special thanks to ScaBBy for making it xor  Routine!
;------------------

;hl = image
;a = x coord
;e = y coord

PutSprite:
 push hl ; Save sprite address

; Calculate the address in graphbuf 

 ld   hl,0 ; Do y*12
 ld   d,0
 ex de,hl
 add  hl,hl
 add  hl,hl
 add  hl,hl
 add  hl,hl

 ld   d,0 ; Do x/8
 ld   e,a
 srl e
 srl e
 srl e
 add  hl,de

 ld   de,$FC00
 add  hl,de ; add  address to graphbuf

 ld   b,00000111b ; Get the remainder of x/8
 and b
 or   a ; Is this sprite aligned to 8*n,y?
 jp   z,&ALIGN


; Non aligned sprite blit starts here 

 pop  ix ; ix->sprite
 ld   d,a ; d=how many bits to shift each line

 ld   e,8 ; Line loop
LILOP: ld   b,(ix+0) ; Get sprite data

 ld   c,0 ; Shift loop
 push de
SHLOP: srl b
 rr c
 dec  d
 jp   nz,&SHLOP
 pop  de

 ld   a,b ; Write line to graphbuf
 xor  (hl)
 ld   (hl),a
 inc  hl
 ld   a,c
 xor  (hl)
 ld   (hl),a

 ld   bc,15 ; Calculate next line address
 add  hl,bc
 inc  ix ; inc  spritepointer

 dec  e
 jp   nz,&LILOP ; Next line

 jp   &DONE1


; Aligned sprite blit starts here 

ALIGN: ; Blit an aligned sprite to graphbuf
 pop  de ; de->sprite
 ld   b,8
ALOP1:
 ld   a,(de)
 xor  (hl) ; xor=erase/blit
 ld   (hl),a
 inc  de
 push bc
 ld   bc,16
 add  hl,bc
 pop  bc
 djnz ALOP1

DONE1:
 ret

;-----------------------Include File for BGround ---------------------------

#include "dhunt.asm" ;Graphic is Saved in this File

;--------------------------------Sprites----------------------------------

gun: 
 .db 00000000b
 .db 00000000b
 .db 00100100b
 .db 00011000b
 .db 00011000b
 .db 00100100b
 .db 00000000b
 .db 00000000b
drwu: 
 .db 01000000b
 .db 01100011b
 .db 00110100b
 .db 01111000b
 .db 11110000b
 .db 01000000b
 .db 00000000b
 .db 00000000b
drwd: 
 .db 00000011b
 .db 00000100b
 .db 01111000b
 .db 11111000b
 .db 01001100b
 .db 00000000b
 .db 00000000b
 .db 00000000b
dlwu: 
 .db 00000010b
 .db 11000110b
 .db 00101100b
 .db 00011110b
 .db 00001111b
 .db 00000010b
 .db 00000000b
 .db 00000000b
dlwd: 
 .db 11000000b
 .db 00100000b
 .db 00011110b
 .db 00011111b
 .db 00110010b
 .db 00000000b
 .db 00000000b
 .db 00000000b

faway: 
 .db 00001000b
 .db 00001000b
 .db 00011100b
 .db 00111110b
 .db 01101011b
 .db 00101010b
 .db 00010100b
 .db 00000000b

shot:
.db 00000000b
.db 01000010b
.db 00111100b
.db 00100100b
.db 00100100b
.db 00111100b
.db 01000010b
.db 00000000b

hitduck: 
 .db 00000100b
 .db 00010100b
 .db 00011110b
 .db 00011110b
 .db 00011100b
 .db 00001000b
 .db 00001000b
 .db 00000000b

;-------------------------Begin Text Strings ------------------------------

CREDITS1:
 .db "Original by "
 .db "Andrew Ungvarsky",0
CREDITS2:
 .db "TI-85 port by"
 .db " Miklos Bergou",0
CONTROLS:
 .db "Ingame controls:",0
SECONDSHOOTS:
 .db "[2nd] - fire",0
ENTERPAUSE:
 .db "[MORE] - pause",0
EXITQUITS:
 .db "[EXIT] - quit",0
HIGHSCORE:
 .db "High score: 0000 by AAA",0
rnd:
 .db "Round ",0
hits:
 .db "Hit ",0
outof10 .db " out of 10 ducks!",0
fas:
 .db "Fly Away!",0
rndclr:
 .db "Round Clear!",0
youhit:
 .db "You hit ",0
andneed:
 .db " and needed ",0
prsclr:
 .db "(Press Enter)",0
gameover:
 .db "Game Over!",0
congrats1:
 .db "Congratulations! You are",0
congrats2:
 .db "a hunting machine. BUT,",0
congrats3:
 .db "since I hate hunting,",0
congrats4:
 .db "there`s no cool ending. SORRY!",0
scr:
 .db "Score =",0
perfect:
 .db "PERFECT!",0
bonus:
 .db "250 point BONUS!",0

newscore:
 .db "-->New High Score!<--",0
hiscore:
 .dw 0


;----------------------Define All Needed Variables-------------------------
duckx   =TEXT_MEM    ;Duck X Coord
ducky   =TEXT_MEM+1  ;Duck Y Coord
wing    =TEXT_MEM+2  ;Wing Up/Down (1-Up, 2-Down)
dirlr   =TEXT_MEM+3  ;Moving Left/Right (1-Right, 2-Left)
dirud   =TEXT_MEM+4  ;Moving Up/Down (1-Up, 2-Down)
moves   =TEXT_MEM+5  ;Number of Moves
gunx    =TEXT_MEM+7  ;Gun X Coord
guny    =TEXT_MEM+8  ;Gun Y Coord
score   =TEXT_MEM+9  ;Your Score
bullets =TEXT_MEM+11 ;Bullets Remaining
curduck =TEXT_MEM+12 ;Current Duck # (1-10)
needed  =TEXT_MEM+13 ;Ducks Needed
dhit    =TEXT_MEM+14 ;Number of Ducks Hit
round   =TEXT_MEM+15 ;Round
dlay    =TEXT_MEM+16 ;Delay Number
noLet   =TEXT_MEM+18

.end

